// ddiff/dpatch - manipulate differences between debian packages.
// Copyright 2000 Tom Rothamel <tom-ddiff@onegeek.org>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  

#ifndef DEBDIFF_H
#define DEBDIFF_H

#include <stdio.h>
#include "version.h"
#include "genfile.h"

extern FILE *outf;
extern int verbose;
extern int ocomments;
#define oprintf(fmt, args...) fprintf(outf, fmt , ## args)
#define comment(fmt, args...) if (ocomments) fprintf(outf, fmt, ## args)
#define err(fmt, args...) fprintf(stderr, "ddiff error: " fmt "\n" , ## args)
#define verbose(fmt, args...) if(verbose) fprintf(stderr, "ddiff: " fmt "\n" , ## args)

// bdiff.cc
void bdiff_init(int);
void bdiff_free();
void bdiff(GFILE *, GFILE *, FILE *);

// debdiff.cc
void die();

// dwrite.cc
char *quote(char *);

void straightdata(FILE *, GFILE *);
void moi(FILE *, char *, char *);
void writebdiff(FILE *, GFILE *, GFILE *);

// These are deprecated because it's too slow to figure out if we need them
// or not.
//
// int copyin(FILE *, GFILE *, char *, char *);
// int blockbyblock(FILE *, GFILE *, char *, char *, GFILE *);

#endif
