// ddiff/dpatch - manipulate differences between debian packages.
// Copyright 2000 Tom Rothamel <tom-ddiff@onegeek.org>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  

#ifndef PKG_H
#define PKG_H

#include "genfile.h"

struct Pkg {
	// Please note that the gfile that this returns will be
	// automatically deleted when element (or any other member) is
	// called again, and it should _not_ be deleted manually.
	virtual GFILE *element(char *, char *) = 0;

	virtual char *name() = 0;
	virtual char *version() = 0;
	virtual char *arch() = 0;
	
	virtual ~Pkg() {}
};

// debpkg.cc
Pkg *open_deb(char *);

#endif
